--- src/event-msw.c.old	Wed Dec 22 22:12:00 1999
+++ src/event-msw.c	Sat Dec 25 13:05:43 1999
@@ -1331,6 +1331,11 @@
 	}
 
       active = select (MAXDESC, &temp_mask, 0, 0, pointer_to_this);
+      /* the following loop hacks around what seems to be a bug in cygwin
+         implementation of select - it should never return 0 in such cases
+         but it does. The loop "fixes" that (cygwin b20). */
+      while (active == 0 && badly_p)
+          active = select (MAXDESC, &temp_mask, 0, 0, 0);
 
       if (active == 0)
 	{
@@ -3083,6 +3088,7 @@
 #ifdef HAVE_MSG_SELECT
   windows_fd = open("/dev/windows", O_RDONLY | O_NONBLOCK, 0);
   assert (windows_fd>=0);
+  FD_ZERO(&input_wait_mask);
   FD_SET (windows_fd, &input_wait_mask);
   FD_ZERO(&zero_mask);
 #endif
